/*************************************************************************/
/*
 *  Datei           : main.cpp
 *  Inhalt          : Testprogram fuer die Klasse Calculator !
 *  Programmierer   : Sven Goethel
 *					  Stapenhorststr.35a
 *					  33615 Bielefeld
 *					  0521/139228
 *  Erstellungsdatum: 06.07.1994
 *  nderungsdatum  :
 *  Projekt         : calc
 *  Verzeichnis     :
 *  Dokumentation   : calc.doc
 *
 *
 * $Log: main.cc  $
 * Revision 2.26  1995/06/06 08:48:27  Sven_Goethel_DFP
 * ok
 * Revision 2.25  1995/06/06 08:20:25  Sven_Goethel_DFP
 * lokale char Buffer mit fester Groesse -> lokale StrClass (dynamische groesse)
 * Revision 2.24  1995/04/07 11:35:11  Sven_Goethel_DFP
 * t_string wieder zurueck zu StrClass
 * Alles angepasst fuer Horts
 * ( aehh Horst . )
 * Wenn __SHOW_CALC__ definiert ist,
 * so werden Zeichen auf stderr gedruckt bei :
 *   PARSEN der DATEI
 *   INTERPRETIEREN der DATENSTRUKTUR
 * und alles fuer Calculator NEU und OLD
 * Revision 2.22  1995/04/05 07:45:41  Sven_Goethel_DFP
 * Alle Fehler behoben ..
 * getestet mit und ohne __OLD_INTERPRETE__ !
 * Fuer den neuen Interpreter sind Fehler-Message (FILE und ZEILENNUMMER)
 * hinzugekommen.
 * Fuer __OLD_INTERPRETE__ wurde ein BUG entfernt :
 *   bei return innerhalb verschachtelter Bloecke wurde der 
 *   Block zaehler nicht wieder zureuckgesetzt !!!
 * Revision 2.21  1995/04/05 02:00:33  Sven_Goethel_DFP
 * profekt-pflege nun mit KornShell-Sripts
 * Revision 2.2  1995/04/05 01:48:29  Sven_Goethel_DFP
 * __Mem_Free fehler beseitigt
 * Das MKS System hat um ein mittels new allokiertes Array zu deallokieren,
 * den delete operator verwendet.
 * Es muss aber der delete[] operator verwendet werden :
 *   int *p=new int[100];
 *   delete p; // Error !
 *   delete[] p; // Ok !
 * Revision 2.1  1995/04/01 02:41:36  Sven_Goethel_DFP
 * Referenz fuer Globale Variablen beseitigt, da FEHLER !!!!
 * Das Watcom-Executable stuerzt ab, wenn mehr als zwei ELSE zweige
 * existieren ( oder schon ab zwei ??) <- im test mit test.clc zu ersehen.
 * Das Borland C++ 4.0 executable hingegen arbeitet fehlerfrei !!!
 * Revision 1.6  1995/02/28 15:08:01  Sven_Goethel_WPP
 * source ist nun mit borland c++ version 4.0
 * und mit watcom c++ version 10.0 zu uebersetzen !!!!
 * Revision 1.3  1995/01/30 08:18:15  Sven_Goethel
 * 1st full implemented & checked version
 * Revision 1.2  1995/01/27 17:45:21  Sven_Goethel
 * break - 
 * Revision 1.1  1994/12/16 16:52:16  Sven_Goethel
 * Initial revision
 *
 *    (C) Copyright Dr.-Ing.F.Prekwinkel GmbH, 32052 Herford, Germany
 */
/*************************************************************************/

# include <stdio.h>
//# include <new.h>
# include "calc.h"

int main (int argc, char *argv[])
{
  // um das alte VErhalten von NEW zu erzeugen.....
	// return 0 bei KEIN-MEMORY.
  //set_new_handler(0);

  FILE *fTestFile=NULL;

  if(argc!=2) 
	{
	  printf("usage : %s <clc-file>\n", argv[0]);
		return 0;
  }
  if((fTestFile=fopen(argv[1],"rt"))==NULL)
		INT_ERR(__LINE__);

  Calculator Calc, Calc2;
  Calc.AbortOnError(__LINE__); // Fehler abfangen !!!!!
  Calc2.AbortOnError(__LINE__); // Fehler abfangen !!!!!

  // Calc fuettern
  Calc.Declare("real a=3");
  Calc.AbortOnError(__LINE__); // Fehler abfangen !!!!!

  Calc.DeclareReal("b", 4);
  Calc.AbortOnError(__LINE__); // Fehler abfangen !!!!!

  Calc.DeclareReal("c");
  Calc.AbortOnError(__LINE__); // Fehler abfangen !!!!!

  Calc.SetReal("c", 2);
  Calc.AbortOnError(__LINE__); // Fehler abfangen !!!!!

  // Calc2 fuettern
  Calc2.Declare("real a=3");
  Calc2.AbortOnError(__LINE__); // Fehler abfangen !!!!!

  Calc2.DeclareReal("b", 4);
  Calc2.AbortOnError(__LINE__); // Fehler abfangen !!!!!

  Calc2.DeclareReal("c");
  Calc2.AbortOnError(__LINE__); // Fehler abfangen !!!!!

  Calc2.SetReal("c", 2);
  Calc2.AbortOnError(__LINE__); // Fehler abfangen !!!!!

  // Calc Ausgabe
  printf("<CALC> %lf+%lf*%lf=%lf\n",
	Calc.GetReal("a"), Calc.GetReal("b"), Calc.GetReal("c"),
	Calc.GetRealExpr("a+b*c")
  );
  Calc.AbortOnError(__LINE__); // Fehler abfangen !!!!!

  // Calc2 Ausgabe
  printf("<CALC2> %lf+%lf*%lf=%lf\n",
	Calc2.GetReal("a"), Calc2.GetReal("b"), Calc2.GetReal("c"),
	Calc2.GetRealExpr("a+b*c")
  );
  Calc2.AbortOnError(__LINE__); // Fehler abfangen !!!!!

  // Calc Clear all Variables
  Calc.Reset();
  Calc.AbortOnError(__LINE__); // Fehler abfangen !!!!!

  Calc.Declare("real a=2");
  Calc.AbortOnError(__LINE__); // Fehler abfangen !!!!!

  Calc.DeclareReal("b", 7.1);
  Calc.AbortOnError(__LINE__); // Fehler abfangen !!!!!

  Calc.DeclareReal("c");
  Calc.AbortOnError(__LINE__); // Fehler abfangen !!!!!

  Calc.SetReal("c", 2.3);
  Calc.AbortOnError(__LINE__); // Fehler abfangen !!!!!

  // Calc Ausgabe
  printf("<CALC> %lf+%lf*%lf=%lf\n",
	Calc.GetReal("a"), Calc.GetReal("b"), Calc.GetReal("c"),
	Calc.GetRealExpr("a+b*c")
  );
  Calc.AbortOnError(__LINE__); // Fehler abfangen !!!!!

  // Calc : File abarbeiten
  Calc.Reset();
  Calc.AbortOnError(__LINE__); // Fehler abfangen !!!!!

  Calc.Declare("int init=0");
  Calc.AbortOnError(__LINE__); // Fehler abfangen !!!!!

	printf("<CALC_MAIN> Interprete(fTestFile)\n");
  Calc.SetInputFileName(argv[1]);
  Calc.Interprete(fTestFile);
  Calc.AbortOnError(__LINE__); // Fehler abfangen !!!!!

	printf("<CALC_MAIN> Interprete(fTestFile)\n");
  Calc.SetInputFileName(argv[1]);
  Calc.Interprete(fTestFile);
  Calc.AbortOnError(__LINE__); // Fehler abfangen !!!!!

  // Calc Ausgabe
  char *Save=Calc.GetStringCopy("ResultName");
  Calc.AbortOnError(__LINE__); // Fehler abfangen !!!!!
  printf("<CALC> %s : %.2lf\n", Save,
							  Calc.GetReal("RESULT"));
  Calc.AbortOnError(__LINE__); // Fehler abfangen !!!!!

  if(Save) free(Save); // Sei sicher die erhaltene String-Copie zu loeschen !!

  // Calc2 : File 
  Calc2.Reset();
  Calc2.AbortOnError(__LINE__); // Fehler abfangen !!!!!

  Calc2.Declare("int init=0");
  Calc2.AbortOnError(__LINE__); // Fehler abfangen !!!!!

	printf("<CALC_MAIN> Interprete(fTestFile)\n");
  Calc2.SetInputFileName(argv[1]);
  Calc2.Interprete(fTestFile);
  Calc2.AbortOnError(__LINE__); // Fehler abfangen !!!!!

	printf("<CALC_MAIN> Interprete(fTestFile)\n");
  Calc2.SetInputFileName(argv[1]);
  Calc2.Interprete(fTestFile);
  Calc2.AbortOnError(__LINE__); // Fehler abfangen !!!!!

  // Calc2 Ausgabe
  printf("<CALC2> %s : %lf\n", Calc2.GetString("ResultName"),
							   Calc.GetReal("RESULT"));
  Calc2.AbortOnError(__LINE__); // Fehler abfangen !!!!!

  // Automatisches Loeschen der Calculatoren !!!!!!!
  // mit Verlassen ihres Gueltigkeitsbereich !!!!!!!
  return(0);
}
