
/*
** $Log: objprete.cc  $
** Revision 2.26  1995/06/06 08:48:28  Sven_Goethel_DFP
** ok
** Revision 2.25  1995/06/06 08:20:26  Sven_Goethel_DFP
** lokale char Buffer mit fester Groesse -> lokale StrClass (dynamische groesse)
** Revision 2.24  1995/04/07 11:35:14  Sven_Goethel_DFP
** t_string wieder zurueck zu StrClass
** Alles angepasst fuer Horts
** ( aehh Horst . )
** Wenn __SHOW_CALC__ definiert ist,
** so werden Zeichen auf stderr gedruckt bei :
**   PARSEN der DATEI
**   INTERPRETIEREN der DATENSTRUKTUR
** und alles fuer Calculator NEU und OLD
** Revision 2.22  1995/04/05 07:45:43  Sven_Goethel_DFP
** Alle Fehler behoben ..
** getestet mit und ohne __OLD_INTERPRETE__ !
** Fuer den neuen Interpreter sind Fehler-Message (FILE und ZEILENNUMMER)
** hinzugekommen.
** Fuer __OLD_INTERPRETE__ wurde ein BUG entfernt :
**   bei return innerhalb verschachtelter Bloecke wurde der 
**   Block zaehler nicht wieder zureuckgesetzt !!!
** Revision 2.21  1995/04/05 02:00:37  Sven_Goethel_DFP
** profekt-pflege nun mit KornShell-Sripts
** Revision 2.2  1995/04/05 01:48:38  Sven_Goethel_DFP
** __Mem_Free fehler beseitigt
** Das MKS System hat um ein mittels new allokiertes Array zu deallokieren,
** den delete operator verwendet.
** Es muss aber der delete[] operator verwendet werden :
**   int *p=new int[100];
**   delete p; // Error !
**   delete[] p; // Ok !
** Revision 2.1  1995/04/01 02:41:37  Sven_Goethel_DFP
** Referenz fuer Globale Variablen beseitigt, da FEHLER !!!!
** Das Watcom-Executable stuerzt ab, wenn mehr als zwei ELSE zweige
** existieren ( oder schon ab zwei ??) <- im test mit test.clc zu ersehen.
** Das Borland C++ 4.0 executable hingegen arbeitet fehlerfrei !!!
** Revision 1.6  1995/02/28 15:08:04  Sven_Goethel_WPP
** source ist nun mit borland c++ version 4.0
** und mit watcom c++ version 10.0 zu uebersetzen !!!!
** Revision 1.3  1995/01/30 08:18:17  Sven_Goethel
** 1st full implemented & checked version
** Revision 1.2  1995/01/27 17:45:23  Sven_Goethel
** break - 
** Revision 1.1  1995/01/23 07:01:52  Sven_Goethel
** Initial revision
**
*/

#include "objprete.h"

// one for all !!!!!!!!!!!
int BlockLevel::Level = 0;
int BlockLevel::Skip  = 0;

#ifdef MEM_STATISTICS
  static long Copys=0;
  static long HashVars=0;
  #define INC_COPYS Copys++;
  #define INC_HASHVARS HashVars++;
#else
  #define INC_COPYS 
  #define INC_HASHVARS 
#endif

Ausdruck::Ausdruck() {}

void Ausdruck::copy( const Ausdruck & ) { }

VariablenInhalt Ausdruck::Do() 
{
  VariablenInhalt vi (Level, INT, 0, NULL);
  return vi;
}

Summand::Summand( Produkt & p )
: pLAusdruck(NULL), pRProdukt(&p), task(T_UNAER) 
{ }

Summand::Summand( Ausdruck & la, Produkt & rp, Task t )
: pLAusdruck(&la), pRProdukt(&rp), task(t) 
{}

VariablenInhalt Summand::Do() 
{
  if(Skip)
  {
    VariablenInhalt vi (Level, INT, 0, NULL);
    return vi;
  }
  assert(task==T_UNAER&&pLAusdruck==NULL || task!=T_UNAER &&pLAusdruck!=NULL);
  VariablenInhalt vl, vr, result;

  if(pRProdukt) vr=pRProdukt->Do();
  else INT_ERR(__LINE__);
  if(pLAusdruck) vl=pLAusdruck->Do();

  switch (task)
  {
    case T_UNAER   : result=vr;
                     break;
    case T_ADD     : if(vl.Type==STRING&&vr.Type==STRING)
                    {
                      result.Set(STRING, Level, 0, vl.strInhalt.GetStrPtr());
                      result.strInhalt.StrCat(vr.strInhalt);
                    } 
                    else 
                      result.Set ( vl.GetBiggestType(vr), Level, 
                                   vl.rInhalt+vr.rInhalt, NULL);
                     break;
    case T_SUB     : result.Set ( vl.GetBiggestType(vr), Level, 
                                 vl.rInhalt-vr.rInhalt, NULL);
                     break;
    default        : INT_ERR(__LINE__);
  }
  return result;
}

Summand::~Summand() 
{ if(pLAusdruck) delete pLAusdruck; 
  if(pRProdukt) delete pRProdukt; 
}

void Summand::copy( const Summand & m )
{
  INC_COPYS; 
  task=m.task;
  if(m.pLAusdruck) pLAusdruck=m.pLAusdruck->clone();
  else pLAusdruck=NULL;
  if(m.pRProdukt) pRProdukt=m.pRProdukt->clone();
  else pRProdukt=NULL;
}

VariablenInhalt Vergleich::Do() 
{
  if(Skip)
  {
    VariablenInhalt vi (Level, INT, 0, NULL);
    return vi;
  }
  VariablenInhalt vl, vr, result;

  if(pRAusdruck) vr=pRAusdruck->Do();
  else INT_ERR(__LINE__);
  if(pLAusdruck) vl=pLAusdruck->Do();
  else INT_ERR(__LINE__);

  switch (task)
  {
    case T_EQ :
                    result.Set(INT, Level, vl==vr, NULL);
                    break;
    case T_GE:
                    result.Set(INT, Level, vl>=vr, NULL);
                    break;
    case T_GT:
                    result.Set(INT, Level, vl>vr, NULL);
                    break;
    case T_LT:
                    result.Set(INT, Level, vl<vr, NULL);
                    break;
    case T_LE:
                    result.Set(INT, Level, vl<=vr, NULL);
                    break;
    case T_NE:
                    result.Set(INT, Level, vl!=vr, NULL);
                    break;
    default:        INT_ERR(__LINE__);
  }
  return result;
}

void Vergleich::copy( const Vergleich & m )
{
  INC_COPYS; 
  task=m.task;
  if(m.pLAusdruck) pLAusdruck=m.pLAusdruck->clone();
  else pLAusdruck=NULL;
  if(m.pRAusdruck) pRAusdruck=m.pRAusdruck->clone();
  else pRAusdruck=NULL;
}

VariablenInhalt Zuweisung::Do() 
{
  if(Skip)
  {
    VariablenInhalt vi (Level, INT, 0, NULL);
    return vi;
  }

  assert(pVars!=NULL);

  VariablenInhalt idx, val;

  if(pIdxAusdruck) idx=pIdxAusdruck->Do();
  if(pRAusdruck) val=pRAusdruck->Do();
  else INT_ERR(__LINE__);

  if(!pIdxAusdruck)
  {
		INC_HASHVARS; 
		if ( ! pVars->SetzeWert(Level, Bezeichner.GetStrPtr(), val) )
		{
			fprintf(stderr, 
				"\n<CALC> VAR Zugriff Fehler (Falsche TypenKonversion oder Falscher Gueltigkeitbereich),\n Variable : %s", Bezeichner.GetStrPtr());
			fprintf(stderr, "\n<CALC> %s", GetErrorMsg());
			exit(1);
    }
  }
  else 
  {
    VariablenInhalt vi;
		INC_HASHVARS; 
		if( ! pVars->HoleWert(Level, Bezeichner.GetStrPtr(), vi) )
		{
			fprintf(stderr, 
				"\n<CALC> VAR Zugriff Fehler (Falscher Gueltigkeitbereich),\n Variable : %s", Bezeichner.GetStrPtr());
			fprintf(stderr, "\n<CALC> %s", GetErrorMsg());
			exit(1);
    }
    // Nur fuer vi.Type==STRING !!!!!!
    if(vi.Type==STRING)
    {
      if(idx.Type!=STRING)
      {
        (vi.strInhalt.GetStrPtr())[(int)(idx.rInhalt)]=(int)(val.rInhalt);
				if ( !pVars->SetzeWert(Level, Bezeichner.GetStrPtr(), vi) )
				{
					fprintf(stderr,
						"\n<CALC> VAR Zugriff Fehler (Falsche TypenKonversion oder Falscher Gueltigkeitbereich),\n");
					fprintf(stderr, "\n<CALC> %s", GetErrorMsg());
					exit(1);
        }
      } else {
          fprintf(stderr,
            "\n<CALC> LOKALE-VAR Zugriff Fehler (Index muss eine Zahl sein !),\n ");
					fprintf(stderr, "\n<CALC> %s", GetErrorMsg());
					exit(1);
      }
    } else {
        fprintf(stderr, "\n<CALC> LOKALE-VAR Zugriff Fehler (Array-Dereferenzierer nur fuer STRINGS !),\n");
				fprintf(stderr, "\n<CALC> %s", GetErrorMsg());
				exit(1);
    }
  }
  return val;
}

void Zuweisung::copy( const Zuweisung & m )
{
  INC_COPYS; 
  if(m.pIdxAusdruck) pIdxAusdruck=m.pIdxAusdruck->clone();
  else pIdxAusdruck=NULL;
  if(m.pRAusdruck) pRAusdruck=m.pRAusdruck->clone();
  else pRAusdruck=NULL;
  Bezeichner=m.Bezeichner;
  pVars=m.pVars;
}

VariablenInhalt Boolean::Do() 
{
  if(Skip)
  {
    VariablenInhalt vi (Level, INT, 0, NULL);
    return vi;
  }
  VariablenInhalt vl, vr, result;

  if(pRAusdruck) vr=pRAusdruck->Do();
  else INT_ERR(__LINE__);
  if(pLAusdruck) vl=pLAusdruck->Do();
  else INT_ERR(__LINE__);

  switch (task)
  {
    case T_AND :
                    result.Set(INT, Level, vl&&vr, NULL);
                    break;
    case T_OR:
                    result.Set(INT, Level, vl||vr, NULL);
                    break;
    default:        INT_ERR(__LINE__);
  }
  return result;
}

void Boolean::copy( const Boolean & m )
{
  INC_COPYS; 
  task=m.task;
  if(m.pLAusdruck) pLAusdruck=m.pLAusdruck->clone();
  else pLAusdruck=NULL;
  if(m.pRAusdruck) pRAusdruck=m.pRAusdruck->clone();
  else pRAusdruck=NULL;
}

void Anweisung::Do() 
{}

void Anweisung::copy(const Anweisung & )
{}

Return::Return( Ausdruck &asdrck, Funktionen &fkten, int idx )
: pAusdruck(&asdrck), pFunktionen(&fkten), FIdx(idx) {}

Return::~Return() 
{ if(pAusdruck) delete pAusdruck; }

void Return::Do() 
{
  assert(pFunktionen!=NULL);
  assert(pAusdruck!=NULL);
  if(!Skip)
  {
    (pFunktionen->ReturnValListe)[FIdx]=pAusdruck->Do();
    Skip=1;
  }
}

void Return::copy(const Return &m)
{
  INC_COPYS; 
  pFunktionen=m.pFunktionen;
  if(m.pAusdruck) pAusdruck=m.pAusdruck->clone();
  else pAusdruck=NULL;
  FIdx=m.FIdx;
}

void Verzweigung::Do() 
{
  if(Skip) return;
  if(!pAusdruck) INT_ERR(__LINE__);
  if(!pAnweisung) INT_ERR(__LINE__);
  if(!pAnweisungElse) INT_ERR(__LINE__);

  if(pAusdruck->Do())
    pAnweisung->Do();
  else 
    pAnweisungElse->Do();
} 

Verzweigung::~Verzweigung() 
{ 
  if(pAusdruck) delete pAusdruck;
  if(pAnweisung) delete pAnweisung;
  if(pAnweisungElse) delete pAnweisungElse;
}

void Verzweigung::copy( const Verzweigung & m )
{
  INC_COPYS; 
  if(m.pAusdruck) pAusdruck=m.pAusdruck->clone();
  else pAusdruck=NULL;
  if(m.pAnweisung) pAnweisung=m.pAnweisung->clone();
  else pAnweisung=NULL;
  if(m.pAnweisungElse) pAnweisungElse=m.pAnweisungElse->clone();
  else pAnweisungElse=NULL;
}

void Schleife::Do() 
{
  if(Skip) return;
  if(!pAusdruck) INT_ERR(__LINE__);
  if(!pAnweisung) INT_ERR(__LINE__);
  if(task==T_WHILE)
  {
    while(pAusdruck->Do()) pAnweisung->Do();
  }
  else 
  {
    do {
      pAnweisung->Do();
    } while(pAusdruck->Do());
  }
} 

Schleife::~Schleife() 
{ 
  if(pAusdruck) delete pAusdruck;
  if(pAnweisung) delete pAnweisung;
}

void Schleife::copy( const Schleife & m )
{
  INC_COPYS; 
  task=m.task;
  if(m.pAusdruck) pAusdruck=m.pAusdruck->clone();
  else pAusdruck=NULL;
  if(m.pAnweisung) pAnweisung=m.pAnweisung->clone();
  else pAnweisung=NULL;
}

void AusdruckOpt::Do() 
{ if(Skip) return;
  if(pAusdruck) pAusdruck->Do(); 
}

AusdruckOpt::~AusdruckOpt()
{ if(pAusdruck) delete pAusdruck; }

void AusdruckOpt::copy( const AusdruckOpt & m )
{ if(m.pAusdruck) pAusdruck=m.pAusdruck->clone(); 
  else pAusdruck=NULL;
  INC_COPYS; 
}

VariablenDef::VariablenDef ( const VarType vt, DeepRefListe<Zuweisung> &zl, 
                              Variablen & va, Task t )
: Vt(vt), pZuwRefListe(&zl), pVars(&va), task(t) {}

void VariablenDef::Do() 
{
  if(Skip) return;
  assert(pVars!=NULL);

  for(int i=0; i<pZuwRefListe->laenge(); i++)
  {
    assert((*pZuwRefListe)[i].pRAusdruck!=NULL);

    VariablenInhalt vi=(*pZuwRefListe)[i].pRAusdruck->Do();
    vi.Level=(task==T_NORMAL)?Level:0;
    if ( !pVars->DefiniereVar((*pZuwRefListe)[i].Bezeichner.GetStrPtr(), vi) )
    {
      fprintf(stderr, "\n<CALC> VAR Definition-Fehler (Doppelte Def.), ");
			fprintf(stderr, "\n<CALC> %s", GetErrorMsg());
			exit(1);
    }
  }
}

void VariablenDef::copy( const VariablenDef & m )
{
  INC_COPYS; 
  task=m.task;
  Vt=m.Vt;
  if(m.pZuwRefListe) pZuwRefListe=m.pZuwRefListe->clone();
  else pZuwRefListe=NULL;
  pVars=m.pVars;
}

void Ausgabe::Do() 
{
  if(Skip) return;
  Liste<VariablenInhalt> ArgListe;

  if(pAusdruckListe)
  {
    for(int i=0; i<pAusdruckListe->laenge(); i++)
      ArgListe.fuegeEin((*pAusdruckListe)[i].Do(), ArgListe.laenge());
  }
  Print ( stdout, Str.GetStrPtr(), ArgListe );
}

void Ausgabe::copy( const Ausgabe & m )
{
  INC_COPYS; 
  *((StrClass *)(&Str))=m.Str;
  if(m.pAusdruckListe) pAusdruckListe=m.pAusdruckListe->clone();
  else pAusdruckListe=NULL;
}

void Exit::Do() 
{
  if(Skip) return;
  VariablenInhalt vi(0, INT, 0, NULL);
  if(pAusdruck) vi=pAusdruck->Do();

  if(vi.Type==STRING)
  {
    fprintf(stderr, "\n<CALC> Fehler Exit-Parameter muss eine Zahl sein !\n ");
		fprintf(stderr, "\n<CALC> %s", GetErrorMsg());
		exit(1);
  }
  exit( (int)(vi.rInhalt) ) ;
}

void Exit::copy( const Exit & m )
{
  INC_COPYS; 
  if(m.pAusdruck) pAusdruck=m.pAusdruck->clone();
  else pAusdruck=NULL;
}

Block::Block( Anweisungen &a, Variablen &Vars )
: pAnweisungen(&a), pVars(&Vars) {}

Block::~Block() 
{ if(pAnweisungen) delete pAnweisungen; }

void Block::Do() 
{ 
  if(Skip) return;
  assert(pAnweisungen!=NULL);
  assert(pVars!=NULL);
  Level++;
  pAnweisungen->Do(); 
  pVars->Loesche(Level);
  Level--;
}

void Block::copy( const Block & m )
{
  INC_COPYS; 
  if(m.pAnweisungen) pAnweisungen=m.pAnweisungen->clone();
  else pAnweisungen=NULL;
  pVars=m.pVars;
}

void Anweisungen::Do() 
{ if(Skip) return;
  for( int i=0; i<laenge(); i++) (*this)[i].Do(); 
}

Produkt::Produkt( Operand & o )
: pLProdukt(NULL), pROperand(&o), pLAusdruck(NULL), pRAusdruck(NULL),
  task(T_UNAER) 
{}

Produkt::Produkt( Produkt & lp, Operand & ro, Task t )
: pLProdukt(&lp), pROperand(&ro), pLAusdruck(NULL), pRAusdruck(NULL),
  task(t)
{}

Produkt::Produkt( Ausdruck & la, Ausdruck & ra, Task t )
: pLProdukt(NULL), pROperand(NULL), pLAusdruck(&la), pRAusdruck(&ra), 
  task(t) 
{}

Produkt::~Produkt() 
{ if(pLProdukt) delete pLProdukt; 
  if(pROperand) delete pROperand; 
  if(pLAusdruck) delete pLAusdruck; 
  if(pRAusdruck) delete pRAusdruck; 
}

VariablenInhalt Produkt::Do() 
{
  if(Skip)
  {
    VariablenInhalt vi (Level, INT, 0, NULL);
    return vi;
  }
  assert ( task==T_UNAER && pLAusdruck==NULL && pRAusdruck==NULL &&
           pLProdukt==NULL || 
           task!=T_UNAER );
  VariablenInhalt vlP, vrO, result, vrA, vlA;

  if(pROperand) vrO=pROperand->Do();
  if(pLProdukt) vlP=pLProdukt->Do();
  if(pRAusdruck) vrA=pRAusdruck->Do();
  if(pLAusdruck) vlA=pLAusdruck->Do();

  switch (task)
  {
    case T_UNAER:      result=vrO;
                      break;
    case T_MUL:       
                      result.Set(vlP.GetBiggestType(vrO), Level, 
                                 vlP.rInhalt*vrO.rInhalt, NULL);
                      break;
    case T_DIV:
                      result.Set(vlP.GetBiggestType(vrO), Level, 
                                 vlP.rInhalt/vrO.rInhalt, NULL);
                      break;
    case T_POW:       if(pRAusdruck==NULL)
                      {
                        assert(pLAusdruck==NULL && pROperand!=NULL && 
                               pLProdukt!=NULL) ;
                        result.Set(vlP.GetBiggestType(vrO), Level, 
                                   pow(vlP.rInhalt,vrO.rInhalt), NULL);
                      } else {
                        result.Set(vlP.GetBiggestType(vrO), Level, 
                                   pow(vlA.rInhalt,vrA.rInhalt), NULL);
                      }
                      break;
    default:          INT_ERR(__LINE__);
  }
  return result;
}

void Produkt::copy( const Produkt & m ) 
{ 
  INC_COPYS; 
  task=m.task;
  if(m.pLProdukt) pLProdukt=m.pLProdukt->clone(); 
  else pLProdukt=NULL;
  if(m.pROperand) pROperand=m.pROperand->clone(); 
  else pROperand=NULL;
  if(m.pLAusdruck) pLAusdruck=m.pLAusdruck->clone(); 
  else pLAusdruck=NULL;
  if(m.pRAusdruck) pRAusdruck=m.pRAusdruck->clone(); 
  else pRAusdruck=NULL;
}

VariablenInhalt Operand::Do() 
{ VariablenInhalt vi(Level, INT, 0, NULL); 
  return vi;
}

VariablenInhalt MathOperand::Do() 
{ 
  if(Skip)
  {
    VariablenInhalt vi (Level, INT, 0, NULL);
    return vi;
  }
  VariablenInhalt result;
  VariablenInhalt vi(0, result.Type); // NULL Wertig !

  if(pOp) result=pOp->Do();
  else INT_ERR(__LINE__);

  if ( result.Type == STRING )
  {
    fprintf(stderr, 
      "\n<CALC> Unaerer Mathematischer Operand ist vom Typ String !\n");
		fprintf(stderr, "\n<CALC> %s", GetErrorMsg());
		exit(1);
  }

  switch (task)
  {
    case T_NOT:       
                      result.Set(INT, Level, result==vi, NULL);
                      break;
    case T_ABS:
                      result.rInhalt=fabs(result.rInhalt);  
                      break;
    case T_NEG:
                      result.rInhalt=(result.rInhalt)*(-1);  
                      break;
    case T_SQRT:
                      result.rInhalt=sqrt(result.rInhalt);  
                      break;
    case T_EXP:
                      result.rInhalt=exp(result.rInhalt);  
                      break;
    case T_LOG:
                      result.rInhalt=log10(result.rInhalt);  
                      break;
    case T_LN:
                      result.rInhalt=log(result.rInhalt);  
                      break;
    case T_ARCTAN:
                      result.rInhalt=atan(result.rInhalt);  
                      break;
    case T_ARCCOS:
                      result.rInhalt=acos(result.rInhalt);  
                      break;
    case T_ARCSIN:
                      result.rInhalt=asin(result.rInhalt);  
                      break;
    case T_TAN:
                      result.rInhalt=tan(result.rInhalt);  
                      break;
    case T_COS:
                      result.rInhalt=cos(result.rInhalt);  
                      break;
    case T_SIN:
                      result.rInhalt=sin(result.rInhalt);  
                      break;
    default:          INT_ERR(__LINE__);
  }
  return result;
}

void MathOperand::copy( const MathOperand & m )
{ 
  INC_COPYS; 
  if(m.pOp) pOp=m.pOp->clone();
  else pOp=NULL;
  task=m.task;
}

ConstOperand::ConstOperand( const VariablenInhalt &vi )
: VarInhalt(vi) {}

VariablenInhalt ConstOperand::Do() 
{
  if(Skip)
  {
    VariablenInhalt vi (Level, INT, 0, NULL);
    return vi;
  }
  return VarInhalt; 
}

void ConstOperand::copy( const ConstOperand & m )
{   
  INC_COPYS; 
  VarInhalt=m.VarInhalt; 
}

FuncCall::FuncCall( Funktionen &Fkten, int f_idx, 
				            DeepRefListe<Ausdruck> & al )
: pFunktionen(&Fkten), FIdx(f_idx), pAListe(&al) 
{ }

VariablenInhalt FuncCall::Do() 
{
  if(Skip)
  {
    VariablenInhalt vi (Level, INT, 0, NULL);
    return vi;
  }
  assert(pAListe!=NULL);
  assert(pFunktionen!=NULL);
  return pFunktionen->Do(FIdx, *pAListe); 
}

void FuncCall::copy(const FuncCall & m)
{    
  INC_COPYS; 
  pFunktionen=m.pFunktionen;
  FIdx=m.FIdx;
  if(m.pAListe!=NULL) pAListe=m.pAListe->clone();
  else pAListe=NULL;
}

VariablenInhalt VarOperand::Do() 
{
  if(Skip)
  {
    VariablenInhalt vi (Level, INT, 0, NULL);
    return vi;
  }

  assert(pVars!=NULL);

  VariablenInhalt result;

  if(pIdxAusdruck==NULL)
  {
		INC_HASHVARS; 
		if(!pVars->HoleWert(Level, Bezeichner.GetStrPtr(), result))
		{
			fprintf(stderr, "\n<CALC> LOKALE-VAR Zugriff Fehler, von Variable %s : ",
				Bezeichner.GetStrPtr());
			fprintf(stderr, "\n<CALC> %s", GetErrorMsg());
			exit(1);
    }
  } 
	else 
	{
    VariablenInhalt vi;
    VariablenInhalt idx=pIdxAusdruck->Do();
		INC_HASHVARS; 
		if(!pVars->HoleWert(Level, Bezeichner.GetStrPtr(), vi))
		{
			fprintf(stderr, "\n<CALC> LOKALE-VAR Zugriff Fehler, von Variable %s : ",
				Bezeichner.GetStrPtr());
			fprintf(stderr, "\n<CALC> %s", GetErrorMsg());
			exit(1);
    }
    // Nur fuer vi.Type==STRING !!!!!!
    if(vi.Type==STRING)
    {
      if(idx.Type!=STRING)
      {
        result.Set(CHAR, Level, 
                   (double)((vi.strInhalt.GetStrPtr())[(int)(idx.rInhalt)])
                  );
      } else {
        fprintf(stderr, "\n<CALC> LOKALE-VAR Zugriff Fehler (Index muss eine Zahl sein !),\n von Variable %s : ", Bezeichner.GetStrPtr());
				fprintf(stderr, "\n<CALC> %s", GetErrorMsg());
				exit(1);
      }
    } else {
      fprintf(stderr, "\n<CALC> LOKALE-VAR Zugriff Fehler (Array-Dereferenzierer nur fuer STRINGS !),\n von Variable %s : ",
        Bezeichner.GetStrPtr());
			fprintf(stderr, "\n<CALC> %s", GetErrorMsg());
			exit(1);
    }
  }
  return result;
}

void VarOperand::copy(const VarOperand & m)
{
  INC_COPYS; 
  Bezeichner=m.Bezeichner;
  if(m.pIdxAusdruck!=NULL) pIdxAusdruck=m.pIdxAusdruck->clone();
  else pIdxAusdruck=NULL;
  pVars=m.pVars;
}

VariablenInhalt AusdruckOperand::Do() 
{ if(!pAusdruck) INT_ERR(__LINE__);
  if(Skip) 
  {
    VariablenInhalt vi (Level, INT, 0, NULL);
    return vi;
  }
  else return pAusdruck->Do(); 
}

void AusdruckOperand::copy(const AusdruckOperand & m)
{
  INC_COPYS; 
  if(m.pAusdruck!=NULL) pAusdruck=m.pAusdruck->clone();
  else pAusdruck=NULL;
}

void Inhalt::Do() 
{ 
  if(Skip) INT_ERR(__LINE__);

  assert (   funktionen.AnweisungenRefListe.laenge() ==
            funktionen.ReturnValListe.laenge() &&
            funktionen.ReturnValListe.laenge() ==
            funktionen.InitVarDefRefListeRefListe.laenge()
         ) ;
  Level=0;
  Skip=0;
  #ifdef MEM_STATISTICS
    Copys=0;
    RefVars=0;
    HashVars=0;
  #endif
  if(pAnweisungen) pAnweisungen->Do(); 
  #ifdef MEM_STATISTICS
    printf("Copys %ld   RefVars %ld   HashVars %ld \n", 
                                        Copys, RefVars, HashVars);
  #endif
  assert(Level==0);
  assert(Skip==0);
} 

void Inhalt::copy(const Inhalt & m )
{
  INC_COPYS; 
  if(m.pAnweisungen) pAnweisungen=m.pAnweisungen->clone();
  else pAnweisungen=NULL;
  funktionen=m.funktionen;
}

VariablenInhalt 
Funktionen::Do(int idx, const DeepRefListe<Ausdruck> &la) 
{
  if(Skip) INT_ERR(__LINE__);
  if(FunktionenOff) INT_ERR(__LINE__);

  assert(pVars!=NULL);
  if( idx < 0 || idx >= InitVarDefRefListeRefListe.laenge() )
  {
		fprintf(stderr, "\n<CALC> Error in Funktion : %s", 
		  (const char *)(Bezeichner[idx]));
		fprintf(stderr, "\n ( 0 < %d < %d NICHT ERFUELLT !!!\n",
		  idx, InitVarDefRefListeRefListe.laenge());
		INT_ERR(__LINE__);
  }

  Level++;

  DeepRefListe<VariablenDef> & InitVarDefRefListe =
                                      InitVarDefRefListeRefListe[idx];

  if(la.laenge()>InitVarDefRefListe.laenge())
	{
		fprintf(stderr, "\n<CALC> Error in Funktion : %s", 
		  (const char *)(Bezeichner[idx]));
    fprintf(stderr,"\nUebergebene Argumente Anzahl = %d", la.laenge());
    fprintf(stderr,"\nFunktions Argumente Anzahl = %d\n",
			InitVarDefRefListe.laenge()); 
    exit(1);
  }

  // Die FunktionsDefaultArgumente der FunktionsDefinition
  // mit den FunktionsArgumenten des FunktionsAufrufes ueberschreiben !!!
  int i;
  for(i=0; i<la.laenge(); i++)
  {
    assert(InitVarDefRefListe[i].pZuwRefListe!=NULL);
    assert(InitVarDefRefListe[i].pZuwRefListe->laenge()==1);

    // Default R-Wert merken !!!
    Ausdruck * pRASave =
                InitVarDefRefListe[i].pZuwRefListe->operator[](0).pRAusdruck;

    // Argument uebertragen !!!!
    InitVarDefRefListe[i].pZuwRefListe->operator[](0).pRAusdruck=&la[i];

    // FunktionsParameter-Variablen Definieren
    InitVarDefRefListe[i].Do();

    // Default R-Wert zurueckschreiben !!!
    InitVarDefRefListe[i].pZuwRefListe->operator[](0).pRAusdruck=pRASave;
  }

  // Die restlichen FunktionsParameter-Variablen Definieren (DEFAULT)
  for(; i<InitVarDefRefListe.laenge(); i++) InitVarDefRefListe[i].Do();

  // Funktionsrumpf ausfuehren
  AnweisungenRefListe[idx].Do();
  Skip=0;

  // Variablen wieder loeschen
  pVars->Loesche(Level);
  Level--;

  return ReturnValListe[idx];
} 

void Funktionen::Del() 
{ 
  if(!FunktionenOff)
  {
    while ( Bezeichner.laenge() ) 
      Bezeichner.loesche(0);
    while ( InitVarDefRefListeRefListe.laenge() ) 
      InitVarDefRefListeRefListe.loesche(0);
    while ( AnweisungenRefListe.laenge() ) 
      AnweisungenRefListe.loesche(0);
    while ( ReturnValListe.laenge() ) 
      ReturnValListe.loesche(0);
    Skip=0;
  }
}

void Funktionen::copy(const Funktionen & m )
{
  INC_COPYS; 
  Bezeichner=m.Bezeichner;
  InitVarDefRefListeRefListe=m.InitVarDefRefListeRefListe;
  AnweisungenRefListe=m.AnweisungenRefListe;
  ReturnValListe=m.ReturnValListe;
  pVars=m.pVars;
  FunktionenOff=m.FunktionenOff;
}

