
/*
** $Log: objprete.h $
** Revision 2.26  1995/06/06 08:48:29  Sven_Goethel_DFP
** ok
** Revision 2.25  1995/06/06 08:20:27  Sven_Goethel_DFP
** lokale char Buffer mit fester Groesse -> lokale StrClass (dynamische groesse)
** Revision 2.24  1995/04/07 11:35:15  Sven_Goethel_DFP
** t_string wieder zurueck zu StrClass
** Alles angepasst fuer Horts
** ( aehh Horst . )
** Wenn __SHOW_CALC__ definiert ist,
** so werden Zeichen auf stderr gedruckt bei :
**   PARSEN der DATEI
**   INTERPRETIEREN der DATENSTRUKTUR
** und alles fuer Calculator NEU und OLD
** Revision 2.22  1995/04/05 07:45:45  Sven_Goethel_DFP
** Alle Fehler behoben ..
** getestet mit und ohne __OLD_INTERPRETE__ !
** Fuer den neuen Interpreter sind Fehler-Message (FILE und ZEILENNUMMER)
** hinzugekommen.
** Fuer __OLD_INTERPRETE__ wurde ein BUG entfernt :
**   bei return innerhalb verschachtelter Bloecke wurde der 
**   Block zaehler nicht wieder zureuckgesetzt !!!
** Revision 2.21  1995/04/05 02:00:40  Sven_Goethel_DFP
** profekt-pflege nun mit KornShell-Sripts
** Revision 2.2  1995/04/05 01:48:41  Sven_Goethel_DFP
** __Mem_Free fehler beseitigt
** Das MKS System hat um ein mittels new allokiertes Array zu deallokieren,
** den delete operator verwendet.
** Es muss aber der delete[] operator verwendet werden :
**   int *p=new int[100];
**   delete p; // Error !
**   delete[] p; // Ok !
** Revision 2.1  1995/04/01 02:41:34  Sven_Goethel_DFP
** Referenz fuer Globale Variablen beseitigt, da FEHLER !!!!
** Das Watcom-Executable stuerzt ab, wenn mehr als zwei ELSE zweige
** existieren ( oder schon ab zwei ??) <- im test mit test.clc zu ersehen.
** Das Borland C++ 4.0 executable hingegen arbeitet fehlerfrei !!!
** Revision 1.6  1995/02/28 15:07:49  Sven_Goethel_WPP
** source ist nun mit borland c++ version 4.0
** und mit watcom c++ version 10.0 zu uebersetzen !!!!
** Revision 1.5  1995/01/30 08:18:01  Sven_Goethel
** 1st full implemented & checked version
** Revision 1.4  1995/01/27 17:45:10  Sven_Goethel
** break - 
** Revision 1.3  1995/01/23 07:02:00  Sven_Goethel
** break
** Revision 1.2  1995/01/23 06:05:30  Sven_Goethel
** nur noch Anweisung
** Revision 1.1  1995/01/23 06:04:04  Sven_Goethel
** Initial revision
**
*/

#ifndef _OBJPRETE_H
  #define _OBJPRETE_H

  #include "strclass.h"
  #include "liste.h"
  #include "deeprefl.h"
  #include "calctype.h"
  #include <assert.h>
  #include <math.h>

  // forward
  class Anweisungen;
  class Produkt;
  class Operand;
  class Zuweisung;
  class Funktionen;

  class BlockLevel
  {
    public:
      static int Level;
      static int Skip;
  };

  class ErrorMsg
  {
    public:
      virtual ~ErrorMsg() {}
      void SetErrorMsg(const StrClass &msg) { Msg=msg; }
      const char * GetErrorMsg() { return (const char *)Msg; }
    private:
      StrClass Msg;
  };

  class Ausdruck : public ErrorMsg, public virtual BlockLevel
  {
    public:
      Ausdruck( );
      Ausdruck( const Ausdruck&m ) { copy(m); }
      virtual ~Ausdruck() {}
      Ausdruck& operator=(const Ausdruck&m)
      {
        if(this!=&m) copy(m);
        return *this;
      }
      virtual Ausdruck* clone()
      { Ausdruck * pA = new Ausdruck (*this); 
        if(!pA) INT_ERR(__LINE__);
        return pA;
      }
      int operator==(const Ausdruck &) const { return 0; }
      virtual VariablenInhalt Do() ;

    private:
      void copy(const Ausdruck&);
  };

  class Summand : public Ausdruck, public virtual BlockLevel
  {
    friend class yy_parse;

    public:
      enum Task { T_UNAER, T_SUB, T_ADD } ;

      Summand( const Summand&m ) { copy(m); }
      virtual ~Summand() ;
      Summand& operator=(const Summand&m)
      {
        if(this!=&m) copy(m);
        return *this;
      }
      virtual Summand* clone()
      { Summand * pS =new Summand (*this); 
        if(!pS) INT_ERR(__LINE__);
        return pS;
      }
      virtual VariablenInhalt Do() ;

    protected:
      Summand( Produkt & p ) ;
      Summand( Ausdruck & la, Produkt & rp, Task t ) ;

      Ausdruck * pLAusdruck;
      Produkt * pRProdukt;
      Task task;

    private:
      void copy(const Summand&);
  };

  class Vergleich : public Ausdruck, public virtual BlockLevel
  {
    friend class yy_parse;

    public:
      enum Task { T_EQ, T_GE, T_GT, T_LT, T_LE, T_NE };

      Vergleich ( const Vergleich &m ) { copy(m); }
      virtual ~Vergleich () 
      { if(pLAusdruck) delete pLAusdruck; 
        if(pRAusdruck) delete pRAusdruck; 
      }
      Vergleich & operator=(const Vergleich &m)
      {
        if(this!=&m) copy(m);
        return *this;
      }
      virtual Vergleich * clone()
      { Vergleich * pA = new Vergleich (*this); 
        if(!pA) INT_ERR(__LINE__);
        return pA;
      }
      virtual VariablenInhalt Do() ;

    protected:
      Vergleich ( Ausdruck & l , Ausdruck & r, Task t )
      : pLAusdruck(&l), pRAusdruck(&r), task(t) {}

      Ausdruck * pLAusdruck;
      Ausdruck * pRAusdruck;
      Task task;

    private:
      void copy(const Vergleich &);
  };

  class Zuweisung : public Ausdruck, public virtual BlockLevel
  {
    friend class yy_parse;
    friend class VariablenDef;
    friend class Funktionen;

    public:
      Zuweisung ( const Zuweisung &m ) { copy(m); }
      virtual ~Zuweisung () 
      { if(pIdxAusdruck) delete pIdxAusdruck; 
        if(pRAusdruck) delete pRAusdruck; 
      }
      Zuweisung & operator=(const Zuweisung &m)
      {
        if(this!=&m) copy(m);
        return *this;
      }
      virtual Zuweisung * clone()
      { Zuweisung * pA = new Zuweisung (*this); 
        if(!pA) INT_ERR(__LINE__);
        return pA;
      }
      int operator==(const Zuweisung &m) const 
      { return Bezeichner==m.Bezeichner; }
      virtual VariablenInhalt Do() ;

    protected:
      Zuweisung ( const StrClass & Bez, Ausdruck & ra, 
                  Variablen & Vars )
      : pIdxAusdruck(NULL), pRAusdruck(&ra), Bezeichner(Bez), 
        pVars(&Vars) {} 

      Zuweisung ( const StrClass & Bez, Ausdruck & ia, 
                  Ausdruck & ra, Variablen & Vars )
      : pIdxAusdruck(&ia), pRAusdruck(&ra), Bezeichner(Bez), 
        pVars(&Vars) {} 

      StrClass Bezeichner;
      Ausdruck * pIdxAusdruck;
      Ausdruck * pRAusdruck;
      Variablen * pVars;

    private:
      void copy(const Zuweisung &);
  };

  class Boolean  : public Ausdruck, public virtual BlockLevel
  {
    friend class yy_parse;

    public:
      enum Task { T_AND, T_OR };

      Boolean ( const Boolean &m ) { copy(m); }
      virtual ~Boolean () 
      { if(pLAusdruck) delete pLAusdruck; 
        if(pRAusdruck) delete pRAusdruck; 
      }

      Boolean& operator=(const Boolean &m)
      {
        if(this!=&m) copy(m);
        return *this;
      }
      virtual Boolean * clone()
      { Boolean * pA = new Boolean (*this); 
        if(!pA) INT_ERR(__LINE__);
        return pA;
      }
      virtual VariablenInhalt Do() ;

    protected:
      Boolean ( Ausdruck & l , Ausdruck & r, Task t )
      : pLAusdruck(&l), pRAusdruck(&r), task(t) {}

      Ausdruck * pLAusdruck;
      Ausdruck * pRAusdruck;
      Task task;

    private:
      void copy(const Boolean &);
  };

  class Anweisung : public ErrorMsg, public virtual BlockLevel
  {
    public:
      Anweisung( ) {}
      Anweisung( const Anweisung &m ) { copy(m); }
      virtual ~Anweisung() {}
      Anweisung& operator=(const Anweisung &m)
      {
        if(this!=&m) copy(m);
        return *this;
      }
      virtual Anweisung * clone()
      { Anweisung * pA = new Anweisung (*this); 
        if(!pA) INT_ERR(__LINE__);
        return pA;
      }
      int operator==(const Anweisung &) const { return 0; }
      virtual void Do() ;

    private:
      void copy(const Anweisung&);
  };

  class Return : public Anweisung, public virtual BlockLevel
  {
    friend class yy_parse;

    public:
      Return( const Return &m ) { copy(m); }
      virtual ~Return() ;

      Return& operator=(const Return &m)
      {
        if(this!=&m) copy(m);
        return *this;
      }

      virtual Return * clone()
      { Return * pA = new Return (*this); 
        if(!pA) INT_ERR(__LINE__);
        return pA;
      }

      virtual void Do() ;

    protected:
      Return( Ausdruck &asdrck, Funktionen &fkten, int idx );

      Ausdruck * pAusdruck;
      Funktionen * pFunktionen;
      int FIdx;

    private:
      void copy(const Return &);
  };

  class Verzweigung : public Anweisung, public virtual BlockLevel
  {
    friend class yy_parse;

    public:
      Verzweigung( const Verzweigung &m ) { copy(m); }
      virtual ~Verzweigung() ;
      Verzweigung& operator=(const Verzweigung &m)
      {
        if(this!=&m) copy(m);
        return *this;
      }
      virtual Verzweigung * clone()
      { Verzweigung * pA = new Verzweigung (*this); 
        if(!pA) INT_ERR(__LINE__);
        return pA;
      }

      virtual void Do() ;

    protected:
      Verzweigung( Ausdruck &asdrck, Anweisung &true_anw,
                   Anweisung &false_anw)
      : pAusdruck(&asdrck), pAnweisung(&true_anw), 
        pAnweisungElse(&false_anw) {}

      Ausdruck * pAusdruck;
      Anweisung * pAnweisung;
      Anweisung * pAnweisungElse;

    private:
      void copy(const Verzweigung &);
  };

  class Schleife : public Anweisung, public virtual BlockLevel
  {
    friend class yy_parse;

    public:
      enum Task { T_WHILE, T_DOWHILE };

      Schleife( const Schleife &m ) { copy(m); }
      virtual ~Schleife() ;
      Schleife& operator=(const Schleife &m)
      {
        if(this!=&m) copy(m);
        return *this;
      }
      virtual Schleife * clone()
      { Schleife * pA = new Schleife (*this); 
        if(!pA) INT_ERR(__LINE__);
        return pA;
      }
      virtual void Do() ;

    protected:
      Schleife( Ausdruck &asdrck, Anweisung &anw, Task t )
      : pAusdruck(&asdrck), pAnweisung(&anw), task(t) {}

      Ausdruck * pAusdruck;
      Anweisung * pAnweisung;
      Task task;

    private:
      void copy(const Schleife &);
  };

  class AusdruckOpt : public Anweisung, public virtual BlockLevel
  {
    friend class yy_parse;

    public:
      AusdruckOpt( const AusdruckOpt &m ) { copy(m); }
      virtual ~AusdruckOpt() ;

      AusdruckOpt& operator=(const AusdruckOpt &m)
      {
        if(this!=&m) copy(m);
        return *this;
      }
      virtual AusdruckOpt * clone()
      { AusdruckOpt * pA = new AusdruckOpt (*this); 
        if(!pA) INT_ERR(__LINE__);
        return pA;
      }

      virtual void Do() ;

    protected:
      AusdruckOpt( ) : pAusdruck(NULL) {}
      AusdruckOpt( Ausdruck & a ) 
      : pAusdruck(&a) {}

      Ausdruck * pAusdruck;

    private:
      void copy(const AusdruckOpt &m ) ;
  };
  
  class VariablenDef : public Anweisung, public virtual BlockLevel
  {
    friend class yy_parse;
    friend class Funktionen;

    public:
      enum Task { T_NORMAL, T_FORCE_GLOBAL } ;

      VariablenDef( const VariablenDef &m ) { copy(m); }
      virtual ~VariablenDef() { if(pZuwRefListe) delete pZuwRefListe; }
      VariablenDef& operator=(const VariablenDef &m)
      {
        if(this!=&m) copy(m);
        return *this;
      }
      virtual VariablenDef * clone()
      { VariablenDef * pA = new VariablenDef (*this); 
        if(!pA) INT_ERR(__LINE__);
        return pA;
      }

      int operator==(const VariablenDef &m) const
      { return Vt==m.Vt; }

      virtual void Do() ;

    protected:
      VariablenDef ( const VarType vt, DeepRefListe<Zuweisung> &zl, 
                     Variablen & va, Task t=T_NORMAL ) ;

      VarType Vt;
      DeepRefListe<Zuweisung> * pZuwRefListe;
      Variablen * pVars;
      Task task;

    private:
      void copy(const VariablenDef &);
  };

  class Ausgabe : public Anweisung, public virtual BlockLevel
  {
    friend class yy_parse;

    public:
      Ausgabe( const Ausgabe &m ) { copy(m); }
      virtual ~Ausgabe() { if(pAusdruckListe) delete pAusdruckListe; }
      Ausgabe& operator=(const Ausgabe &m)
      {
        if(this!=&m) copy(m);
        return *this;
      }
      virtual Ausgabe * clone()
      { Ausgabe * pA = new Ausgabe (*this); 
        if(!pA) INT_ERR(__LINE__);
        return pA;
      }
      virtual void Do() ;

    protected:
      Ausgabe( const StrClass &str, DeepRefListe<Ausdruck> &al )
      : Str(str), pAusdruckListe(&al) {}

      Ausgabe( const StrClass &str)
      : Str(str), pAusdruckListe(NULL) {}

      const StrClass Str;
      DeepRefListe<Ausdruck> * pAusdruckListe;

    private:
      void copy(const Ausgabe &);
  };

  class Exit : public Anweisung, public virtual BlockLevel
  {
    friend class yy_parse;

    public:
      Exit( const Exit &m ) { copy(m); }
      virtual ~Exit() 
      { if(pAusdruck) delete pAusdruck; }

      Exit& operator=(const Exit &m)
      {
        if(this!=&m) copy(m);
        return *this;
      }
      virtual Exit * clone()
      { Exit * pA = new Exit (*this); 
        if(!pA) INT_ERR(__LINE__);
        return pA;
      }
      virtual void Do() ;

    protected:
      Exit( Ausdruck &a )
      : pAusdruck(&a) {}

      Ausdruck * pAusdruck;

    private:
      void copy(const Exit &);
  };

  class Block : public Anweisung, public virtual BlockLevel
  {
    friend class yy_parse;

    public:
      Block( const Block &m ) { copy(m); }
      virtual ~Block() ;

      Block& operator=(const Block &m)
      {
        if(this!=&m) copy(m);
        return *this;
      }
      virtual Block * clone()
      { Block * pA = new Block (*this); 
        if(!pA) INT_ERR(__LINE__);
        return pA;
      }
      virtual void Do() ;

    protected:
      Block( Anweisungen &a, Variablen &Vars );

      Anweisungen * pAnweisungen;
      Variablen *pVars;

    private:
      void copy(const Block &);
  };

  class Anweisungen : public DeepRefListe<Anweisung>, public virtual BlockLevel
  {
    public:
      Anweisungen() {}
      Anweisungen( const Anweisungen &anw) 
      : DeepRefListe<Anweisung>(anw) {}
      Anweisungen& operator=(const Anweisungen & anw)
      { if(this!=&anw) DeepRefListe<Anweisung>::operator=(anw);
        return *this;
      }

      virtual ~Anweisungen() {}

      virtual void Do() ;

      virtual Anweisungen* clone()
      { Anweisungen * pA = new Anweisungen (*this); 
        if(!pA) INT_ERR(__LINE__);
        return pA;
      }
  };

  class Produkt : public ErrorMsg, public virtual BlockLevel
  {
    friend class yy_parse;

    public:
      enum Task { T_UNAER, T_MUL, T_DIV, T_POW } ;

      Produkt( const Produkt&m ) { copy(m); }
      virtual ~Produkt() ;
      Produkt& operator=(const Produkt&m)
      {
        if(this!=&m) copy(m);
        return *this;
      }
      virtual Produkt* clone()
      { Produkt * pA = new Produkt (*this); 
        if(!pA) INT_ERR(__LINE__);
        return pA;
      }
      virtual VariablenInhalt Do() ;

    protected:
      Produkt( Operand & o );

      Produkt( Produkt & lp, Operand & ro, Task t );

      Produkt( Ausdruck & la, Ausdruck & ra, Task t );

      Produkt * pLProdukt;
      Operand * pROperand;
      Ausdruck * pLAusdruck;
      Ausdruck * pRAusdruck;
      Task task;

    private:
      void copy(const Produkt&);
  };

  class Operand : public ErrorMsg, public virtual BlockLevel
  {
    public:
      Operand( ) {}
      virtual ~Operand() {}
      virtual Operand* clone()
      { Operand * pA = new Operand (*this); 
        if(!pA) INT_ERR(__LINE__);
        return pA;
      }
      virtual VariablenInhalt Do() ;
  };

  class MathOperand : public Operand, public virtual BlockLevel
  {
    friend class yy_parse;

    public:
      enum Task { T_NOT, T_ABS, T_NEG, T_SQRT, T_EXP, T_LOG, T_LN,
                  T_ARCTAN, T_ARCCOS, T_ARCSIN, T_TAN, T_COS, T_SIN };

      MathOperand( const MathOperand&m ) { copy(m); }
      virtual ~MathOperand() 
      { if(pOp) delete pOp; }
      MathOperand& operator=(const MathOperand&m)
      {
        if(this!=&m) copy(m);
        return *this;
      }
      virtual MathOperand* clone()
      { MathOperand * pA = new MathOperand (*this); 
        if(!pA) INT_ERR(__LINE__);
        return pA;
      }
      virtual VariablenInhalt Do() ;

    protected:
      MathOperand( Operand &o, Task t)
      : pOp(&o), task(t) {}

      Operand * pOp;
      Task task;

    private:
      void copy(const MathOperand&);
  };

  class ConstOperand : public Operand, public virtual BlockLevel
  {
    public:
      ConstOperand( const VariablenInhalt &vi ) ;
      ConstOperand( const ConstOperand&m ) { copy(m); }
      virtual ~ConstOperand() {}
      ConstOperand& operator=(const ConstOperand&m)
      {
        if(this!=&m) copy(m);
        return *this;
      }
      virtual ConstOperand* clone()
      { ConstOperand * pA = new ConstOperand (*this); 
        if(!pA) INT_ERR(__LINE__);
        return pA;
      }
      virtual VariablenInhalt Do() ;

    protected:
      VariablenInhalt VarInhalt;

    private:
      void copy(const ConstOperand&);
  };

  class FuncCall: public Operand, public virtual BlockLevel
  {
    friend class yy_parse;

    public:
      FuncCall( const FuncCall&m ) { copy(m); }
      virtual ~FuncCall() { if(pAListe) delete pAListe; }
      FuncCall& operator=(const FuncCall&m)
      {
        if(this!=&m) copy(m);
        return *this;
      }
      virtual FuncCall* clone()
      { FuncCall * pA = new FuncCall (*this); 
        if(!pA) INT_ERR(__LINE__);
        return pA;
      }
      virtual VariablenInhalt Do() ;

    protected:
      FuncCall( Funktionen &Fkten, int f_idx, 
               DeepRefListe<Ausdruck> & al );

      Funktionen * pFunktionen;
      int FIdx;
      DeepRefListe<Ausdruck> * pAListe;

    private:
      void copy(const FuncCall&);
  };

  class VarOperand : public Operand, public virtual BlockLevel
  {
    friend class yy_parse;

    public:
      VarOperand ( const VarOperand &m ) { copy(m); }
      virtual ~VarOperand ()
      { if(pIdxAusdruck) delete pIdxAusdruck; }

      VarOperand & operator=(const VarOperand &m)
      {
        if(this!=&m) copy(m);
        return *this;
      }
      virtual VarOperand * clone()
      { VarOperand * pA = new VarOperand (*this); 
        if(!pA) INT_ERR(__LINE__);
        return pA;
      }
      virtual VariablenInhalt Do() ;

    protected:
      VarOperand ( const StrClass & Bez, Variablen & Vars )
      : pIdxAusdruck(NULL), Bezeichner(Bez), pVars(&Vars) {} 

      VarOperand ( const StrClass & Bez, Ausdruck & ia, 
                   Variablen & Vars )
      : pIdxAusdruck(&ia), Bezeichner(Bez), pVars(&Vars) {} 

      StrClass Bezeichner;
      Ausdruck * pIdxAusdruck;
      Variablen * pVars;

    private:
      void copy(const VarOperand &);
  };

  class AusdruckOperand : public Operand, public virtual BlockLevel
  {
    friend class yy_parse;

    public:
      AusdruckOperand ( const AusdruckOperand &m ) { copy(m); }
      virtual ~AusdruckOperand () { if(pAusdruck) delete pAusdruck; }
      AusdruckOperand & operator=(const AusdruckOperand &m)
      {
        if(this!=&m) copy(m);
        return *this;
      }
      virtual AusdruckOperand * clone()
      { AusdruckOperand * pA = new AusdruckOperand (*this); 
        if(!pA) INT_ERR(__LINE__);
        return pA;
      }

      virtual VariablenInhalt Do() ;

    protected:
      AusdruckOperand ( Ausdruck & a )
      : pAusdruck(&a) {}

      Ausdruck * pAusdruck ;

    private:
      void copy(const AusdruckOperand &);
  };

  class Funktionen : public virtual BlockLevel
  {
    friend class yy_parse;
    friend class Inhalt;
    friend class Calculator;
    friend class Return;

    public:
      Funktionen( const Funktionen &m ) { copy(m); }
      Funktionen& operator=(const Funktionen &m)
      {
        if(this!=&m) copy(m);
        return *this;
      }

      VariablenInhalt Do(int idx, const DeepRefListe<Ausdruck> &la) ; 

    protected:
      Funktionen( Variablen &Vars ) : pVars(&Vars), FunktionenOff(0) {}
      Liste<StrClass> Bezeichner;    
      DeepRefListe< DeepRefListe<VariablenDef> > InitVarDefRefListeRefListe;  
      DeepRefListe<Anweisungen> AnweisungenRefListe;  // Die Routinen
      Liste<VariablenInhalt>    ReturnValListe;       // Die Return-Werte !
      Variablen * pVars;

      int FunktionenOff;

      void Del() ;

    private:
      void copy(const Funktionen &);
  };

  class Inhalt : public virtual BlockLevel
  {
    friend class yy_parse;
    friend class Calculator;

    public:
      Inhalt( const Inhalt & i ) : funktionen(i.funktionen) { copy(i); }
      Inhalt & operator=(const Inhalt & i)
      { if(this!=&i) copy(i);
        return *this;
      }
      virtual void Do() ;

    protected:
      Inhalt(Variablen &Vars) : funktionen(Vars), pAnweisungen(NULL) {}
      Anweisungen * pAnweisungen;
      Funktionen  funktionen;
      void Del() 
      { if(pAnweisungen) delete pAnweisungen; 
        funktionen.Del();
      }

    private:
      void copy ( const Inhalt & );
  };

#endif
